Finalizer
Date: 2016-05-24

com.google.common.base.internal

## Class Finalizer

- java.lang.Object
- - com.google.common.base.internal.Finalizer

- All Implemented Interfaces:
    java.lang.Runnable

      public class Finalizer
      extends java.lang.Object
      implements java.lang.Runnable

  Thread that finalizes referents. All references should implement `com.google.common.base.FinalizableReference`.

  While this class is public, we consider it to be *internal* and not part of our published API. It is public so we can access it reflectively across class loaders in secure environments.

  This class can't depend on other Guava code. If we were to load this class in the same class loader as the rest of Guava, this thread would keep an indirect strong reference to the class loader and prevent it from being garbage collected. This poses a problem for environments where you want to throw away the class loader. For example, dynamically reloading a web application or unloading an OSGi bundle.

  `com.google.common.base.FinalizableReferenceQueue` loads this class in its own class loader. That way, this class doesn't prevent the main class loader from getting garbage collected, and this class can detect when the main class loader has been garbage collected and stop itself.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.lang.reflect.Field` | `getInheritableThreadLocalsField()`
    `void` | `run()` Loops continuously, pulling references off the queue and cleaning them up.
    `static void` | `startFinalizer(java.lang.Class<?> finalizableReferenceClass, java.lang.ref.ReferenceQueue<java.lang.Object> queue, java.lang.ref.PhantomReference<java.lang.Object> frqReference)` Starts the Finalizer thread.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### startFinalizer

          public static void startFinalizer(java.lang.Class<?> finalizableReferenceClass,
                            java.lang.ref.ReferenceQueue<java.lang.Object> queue,
                            java.lang.ref.PhantomReference<java.lang.Object> frqReference)

      Starts the Finalizer thread. FinalizableReferenceQueue calls this method reflectively.
      Parameters:
        `finalizableReferenceClass` - FinalizableReference.class.
        `queue` - a reference queue that the thread will poll.
        `frqReference` - a phantom reference to the FinalizableReferenceQueue, which will be queued either when the FinalizableReferenceQueue is no longer referenced anywhere, or when its close() method is called.

    - #### run

          public void run()

      Loops continuously, pulling references off the queue and cleaning them up.
      Specified by:
        `run` in interface `java.lang.Runnable`

    - #### getInheritableThreadLocalsField

          public static java.lang.reflect.Field getInheritableThreadLocalsField()